//
// s2_org.c
//
#include <windows.h>
#include "resource.h"
#include "hubr1040.h"
#include "hubcp130.h"
#include "hubcp13l.h"
#include "subcp1300.h"

LRESULT orgMenu ( HWND, UINT, WPARAM, LPARAM );
LRESULT orgTimer( HWND, UINT, WPARAM, LPARAM );
void	orgSts( HWND );
void	orgLoad( HWND );		//	_Ã_CAO{bNX̏

BOOL CALLBACK orgProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	switch( uMessage ) {
		case WM_SHOWWINDOW:
			orgLoad( hWnd );
			SetTimer( hWnd, IDD_TMR, 110, NULL );
			break ;

		case WM_COMMAND:
			orgMenu( hWnd, uMessage, wParam, lParam ); 
			break;

		case WM_TIMER:
			orgTimer( hWnd, uMessage, wParam, lParam ); 
			break;		

		// I
		case WM_CLOSE:
			closeDev( hWnd );				// foCXI
			KillTimer( hWnd, IDD_TMR );		// ^C}[~
			DestroyWindow( hWnd );			// _CAO{bNX
			break;

		// I
		case WM_DESTROY:
			gDlg = NULL;
			ShowWindow( gWnd, SW_SHOWDEFAULT );		// C̃EBhE\
			break;
	}
	return 0 ;
}

LRESULT orgMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	DWORD	dwRet, dwFh;
	BOOL	bRet;
	char	szBuf[255];
	
	// ZT_A(OLSo㔲oē˓)
	switch( wParam ) {
		case IDC_BTN_ORG1:
			// ELSo~
			hubcp132_SetEls( hDev, 0, (WORD)IsDlgButtonChecked( hWnd, IDC_CHK_XELSA ), 0 );

			// _A[hݒ
			hubcp132_SetOrgMode( hDev, 0, 1 );
			
			// 쑬xݒ
			dwFh = GetDlgItemInt( hWnd, IDC_EDT_FH, &bRet, FALSE ); 
			dwRet = hubcp132_WritFHSpd( hDev, 0, dwFh );
			if( dwRet ) {
				wsprintf( szBuf, "쑬xݒ͈͊Oł.\n߂lF%04xh", dwRet );
				MessageBox( hWnd, szBuf, "", MB_OK );
				break;
			}

			// 샂[hݒ(_A)
			hubcp132_WritOpeMode( hDev, 0, 0x18 );

			// X^[g
			hubcp132_AccStart( hDev, 0x01 );
			
			// ʕ\
			EnableWindow( GetDlgItem(hWnd, IDC_BTN_ORG1), FALSE );
			EnableWindow( GetDlgItem(hWnd, IDC_BTN_ORG2), FALSE );
			EnableWindow( GetDlgItem(hWnd, IDC_BTN_ORG3), FALSE );
			SetDlgItemText( hWnd, IDC_STA_XERR, NULL );
			SetDlgItemText( hWnd, IDC_STA_XINT, NULL );
			break;

		// ZT+GR[__A(OLS ono)
		case IDC_BTN_ORG2:
			// ELSo~
			hubcp132_SetEls( hDev, 0, (WORD)IsDlgButtonChecked( hWnd, IDC_CHK_XELSA ), 0 );

			// _A[hݒ
			hubcp132_SetOrgMode( hDev, 0, 2 );

			// 쑬xݒ
			dwFh = GetDlgItemInt( hWnd, IDC_EDT_FH, &bRet, FALSE ); 
			dwRet = hubcp132_WritFHSpd( hDev, 0, dwFh );
			if( dwRet ) {
				wsprintf( szBuf, "쑬xݒ͈͊Oł.\n߂lF%04xh", dwRet );
				MessageBox( hWnd, szBuf, "", MB_OK );
				break;
			}
			
			// 샂[hݒ(_A)
			hubcp132_WritOpeMode( hDev, 0, 0x18 );

			// X^[g
			hubcp132_AccStart( hDev, 0x01 );

			// ʕ\
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_ORG1 ), FALSE );
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_ORG2 ), FALSE );
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_ORG3 ), FALSE );
			SetDlgItemText( hWnd, IDC_STA_XERR, NULL);
			SetDlgItemText( hWnd, IDC_STA_XINT, NULL);
			break;	

		// ZT_A(ELS ono)
		case IDC_BTN_ORG3:										
			// ELSo~
			hubcp132_SetEls( hDev, 0, (WORD)IsDlgButtonChecked( hWnd, IDC_CHK_XELSA ), 1 );
								
			// _A[hݒ
			hubcp132_SetOrgMode( hDev, 0, 6 );

			// 쑬xݒ
			dwFh = GetDlgItemInt( hWnd, IDC_EDT_FH, &bRet, FALSE ); 
			dwRet = hubcp132_WritFHSpd( hDev, 0, dwFh );
			if(dwRet) {
				wsprintf( szBuf, "쑬xݒ͈͊Oł.\n߂lF%04xh", dwRet );
				MessageBox(hWnd, szBuf, "", MB_OK);
				break;
			}
			
			// 샂[hݒ(_A)
			hubcp132_WritOpeMode(hDev, 0, 0x18);

			// X^[g
			hubcp132_AccStart(hDev, 0x01);

			// ʕ\ 
			EnableWindow(GetDlgItem(hWnd, IDC_BTN_ORG1), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_BTN_ORG2), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_BTN_ORG3), FALSE);
			SetDlgItemText(hWnd, IDC_STA_XERR, NULL);
			SetDlgItemText(hWnd, IDC_STA_XINT, NULL);
			break;
		
		// ~
		case IDC_BTN_STP:
			hubcp132_DecStop(hDev, 0x01);
			break;
		
		// ɐI
		case IDC_CHK_XELSA:
			// ELS A
			hubcp132_SetEls(hDev, 0, 1, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XELSA, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XELSB, BST_UNCHECKED);
			break;

		case IDC_CHK_XELSB:
			// ELS B
			hubcp132_SetEls(hDev, 0, 0, 0);			
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XELSA, BST_UNCHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XELSB, BST_CHECKED);
			break;

		case IDC_CHK_XALMA:
			// SVALM A
			hubcp132_SetSvAlm(hDev, 0, 1, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XALMA, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XALMB, BST_UNCHECKED);
			break;

		case IDC_CHK_XALMB:
			// SVALM B
			hubcp132_SetSvAlm(hDev, 0, 0, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XALMA, BST_UNCHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XALMB, BST_CHECKED);
			break;

		case IDC_CHK_XOLSA:
			// OLS A
			hubcp132_SetOls(hDev, 0, 1);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XOLSA, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XOLSB, BST_UNCHECKED);
			break;

		case IDC_CHK_XOLSB:
			// OLS B
			hubcp132_SetOls(hDev, 0, 0);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XOLSA, BST_UNCHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XOLSB, BST_CHECKED);
			break;
		
		// T[{C^[tF[X
		case IDC_CHK_XSVON:
			// T[{I
			hubcp132_SvOn(hDev, 0x01);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XSVON, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XSVOF, BST_UNCHECKED);
			break;

		case IDC_CHK_XSVOF:
			// T[{It
			hubcp132_SvOff(hDev, 0x01);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XSVOF, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XSVON, BST_UNCHECKED);
			break;
	}
	return 0;
}


//
// user timer
//
LRESULT orgTimer( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	switch( wParam ) {
		case IDD_TMR:
			orgSts( hWnd );
			break;
		default:
			return DefWindowProc( hWnd, uMessage, wParam, lParam );
	}
	return 0 ;
}

//
//	Xe[^XǍ
//
void orgSts( HWND hWnd )
{
	WORD	wMst,wSst,wSpd;
	DWORD	dwRet,dwErr,dwInt,dwPos;

	//  XCXe[^X̓Ǎ
	dwRet = hubcp132_ReadMainSts( hDev, 0, &wMst );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		return;
	}

	//  I
	if( wMst & 0x0030 ) {
		if( wMst & 0x0010 ) {		//  G[
			SetDlgItemText( hWnd, IDC_STA_XINT, "G[I" );			
				
			//  XG[Xe[^XǍ
			dwRet = hubcp132_ReadErrorSts( hDev, 0, &dwErr );
			if( dwErr & 0x20 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "+XELSONɂ~" );
			}
			if( dwErr & 0x40 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "-XELSONɂ~" );
			}
			if( dwErr & 0x80 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "XSVALMONɂ~" );
			}
			if( dwErr & 0x200 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "EMGONɂ~" );
			}
		} else {
			//  Cxg(~)
			//  XCxgXe[^XǍ
			dwRet = hubcp132_ReadEventSts( hDev, 0, &dwInt );
			if( dwInt & 1 ) {
				SetDlgItemText( hWnd, IDC_STA_XINT, "~" );
			}
		}
		EnableWindow(GetDlgItem( hWnd, IDC_BTN_ORG1), TRUE );
		EnableWindow(GetDlgItem( hWnd, IDC_BTN_ORG2), TRUE );
		EnableWindow(GetDlgItem( hWnd, IDC_BTN_ORG3), TRUE );
	}
	
	// XTuXe[^X̓Ǎ
	dwRet = hubcp132_ReadSubSts( hDev, 0, &wSst );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		return;
	}

	//  SVON ʕ\(SVON ONFΐF\CSVON OFFFF\)
	if( wSst & 0x0001 )	
		SendDlgItemMessage( hWnd, IDC_BIT_XSON, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_BIT_XSON, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

	//  SVALM ʕ\(SVALM ONFԐF\CSVALM OFFFF\)
	if( wSst & 0x0800 )	
		SendDlgItemMessage( hWnd, IDC_BIT_XALM, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gRed );
	else				
		SendDlgItemMessage( hWnd, IDC_BIT_XALM, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

	//  +ELS ʕ\(ELS ONFԐF\CELS OFFFF\)
	if( wSst & 0x1000 )	
		SendDlgItemMessage( hWnd, IDC_BIT_XPEL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gRed );
	else				
		SendDlgItemMessage( hWnd, IDC_BIT_XPEL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

	//  -ELS ʕ\(ELS ONFԐF\CELS OFFFF\)
	if( wSst & 0x2000 )	
		SendDlgItemMessage( hWnd, IDC_BIT_XMEL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gRed );
	else				
		SendDlgItemMessage( hWnd, IDC_BIT_XMEL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
	
	//  OLS ʕ\(OLS ONFΐF\COLS OFFFF\)
	if( wSst & 0x4000 )	
		SendDlgItemMessage( hWnd, IDC_BIT_XOLS, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_BIT_XOLS, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

	//  ݎw߈ʒu̓Ǎ
	dwRet = hubcp132_ReadCtr( hDev, 0, 1, &dwPos );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		return;
	}
		
	//  ݎw߈ʒu̕\
	SetDlgItemInt( hWnd, IDC_STA_XPOS, dwPos, TRUE );
	
	//  ݑx̓Ǎ
	dwRet = hubcp132_ReadSpd( hDev, 0, &wSpd );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		return;
	}
	
	//  ݑx̕\
	SetDlgItemInt( hWnd, IDC_STA_XSPD, wSpd, FALSE );
}

//	_Ã_CAO{bNX̏
void orgLoad( HWND hWnd )	
{	
	// {^ݒ	
	CheckDlgButton( hWnd, IDC_CHK_XELSB, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_XALMB, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_XOLSB, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_XSVOF, BST_CHECKED );

	// 쑬xGfB^ݒ
	SetDlgItemText( hWnd, IDC_EDT_FH, "4000" );
	SendDlgItemMessage( hWnd, IDC_EDT_FH, EM_SETLIMITTEXT, 5, 0 );
}