//
// s6_cir.c
//
#include <windows.h>
#include "resource.h"
#include "hubr1040.h"
#include "hubcp130.h"
#include "hubcp13l.h"
#include "subcp1300.h"

LRESULT cirMenu ( HWND, UINT, WPARAM, LPARAM );
LRESULT cirTimer( HWND, UINT, WPARAM, LPARAM );
void	cirSts( HWND );
void	cirLoad( HWND );		// ʒuߓ̃_CAO{bNX̏

BOOL CALLBACK cirProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	switch( uMessage ) {
		case WM_SHOWWINDOW:
			cirLoad( hWnd );
			SetTimer( hWnd, IDD_TMR, 110, NULL );
			break ;

		case WM_COMMAND:
			cirMenu( hWnd, uMessage, wParam, lParam ); 
			break;

		case WM_TIMER:
			cirTimer( hWnd, uMessage, wParam, lParam ); 
			break;		

		// I
		case WM_CLOSE:
			closeDev( hWnd );				// foCXI
			KillTimer( hWnd, IDD_TMR );		// ^C}[~
			DestroyWindow( hWnd );			// _CAO{bNX
			break;

		// I
		case WM_DESTROY:
			gDlg = NULL;
			ShowWindow( gWnd, SW_SHOWDEFAULT );		// C̃EBhE\
			break;
	}
	return 0 ;
}

LRESULT cirMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	BOOL	bRet;
	long	lEnd1,lEnd2,lCnt1,lCnt2;
	
	switch( wParam ) {
		// CW~ʕ
		case IDC_BTN_CW:
			// f[^ݒ
			// I_ʒu
			lEnd1 = GetDlgItemInt( hWnd, IDC_EDT_XEND, &bRet, TRUE ); 
			lEnd2 = GetDlgItemInt( hWnd, IDC_EDT_YEND, &bRet, TRUE ); 

			// Sʒu
			lCnt1 = GetDlgItemInt( hWnd, IDC_EDT_XCNTR, &bRet, TRUE ); 
			lCnt2 = GetDlgItemInt( hWnd, IDC_EDT_YCNTR, &bRet, TRUE ); 
			
			// ~ʕԃf[^ݒ
			hubcp132_WritCircl( hDev, 0, lEnd1, lEnd2, lCnt1, lCnt2 );

			// 샂[hݒ(~ʕԓ(CW))
			hubcp132_WritOpeMode( hDev, 0, 0x64 );
			hubcp132_WritOpeMode( hDev, 1, 0x64 );

			// 쑬xݒ(500pps)
			hubcp132_WritFHSpd( hDev, 0, 500 );

			// 쑬x葬X^[g(X-Y)
			hubcp132_CnstStartFH( hDev, 0x03 );

			// ʕ\
			EnableWindow( GetDlgItem(hWnd, IDC_BTN_CW), FALSE );
			EnableWindow( GetDlgItem(hWnd, IDC_BTN_CCW), FALSE );
			SetDlgItemText( hWnd, IDC_STA_XERR, NULL );
			SetDlgItemText( hWnd, IDC_STA_YERR, NULL );
			SetDlgItemText( hWnd, IDC_STA_XINT, NULL );
			break;

		// CCW~ʕ
		case IDC_BTN_CCW:
			// f[^ݒ
			// I_ʒu
			lEnd1 = GetDlgItemInt( hWnd, IDC_EDT_XEND, &bRet, TRUE ); 
			lEnd2 = GetDlgItemInt( hWnd, IDC_EDT_YEND, &bRet, TRUE ); 

			// Sʒu
			lCnt1 = GetDlgItemInt( hWnd, IDC_EDT_XCNTR, &bRet, TRUE ); 
			lCnt2 = GetDlgItemInt( hWnd, IDC_EDT_YCNTR, &bRet, TRUE ); 
			
			// ~ʕԃf[^ݒ
			hubcp132_WritCircl( hDev, 0, lEnd1, lEnd2, lCnt1, lCnt2 );

			// 샂[hݒ(~ʕԓ(CCW))
			hubcp132_WritOpeMode( hDev, 0, 0x65 );
			hubcp132_WritOpeMode( hDev, 1, 0x65 );

			// 쑬xݒ(500pps)
			hubcp132_WritFHSpd( hDev, 0, 500 );

			// 쑬x葬X^[g(X-Y)
			hubcp132_CnstStartFH( hDev, 0x03 );

			// ʕ\
			EnableWindow( GetDlgItem(hWnd, IDC_BTN_CW), FALSE );
			EnableWindow( GetDlgItem(hWnd, IDC_BTN_CCW), FALSE );
			SetDlgItemText( hWnd, IDC_STA_XERR, NULL );
			SetDlgItemText( hWnd, IDC_STA_YERR, NULL );
			SetDlgItemText( hWnd, IDC_STA_XINT, NULL );
			break;

		// ~
		case IDC_BTN_STP:
			hubcp132_QuickStop( hDev, 0x03 );		// XY~
			break;
			
		// ɐI
		// X
		case IDC_CHK_XELSA:
			// ELS A
			hubcp132_SetEls(hDev, 0, 1, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XELSA, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XELSB, BST_UNCHECKED);
			break;

		case IDC_CHK_XELSB:
			// ELS B
			hubcp132_SetEls(hDev, 0, 0, 0);			
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XELSA, BST_UNCHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XELSB, BST_CHECKED);
			break;

		case IDC_CHK_XALMA:
			// SVALM A
			hubcp132_SetSvAlm(hDev, 0, 1, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XALMA, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XALMB, BST_UNCHECKED);
			break;

		case IDC_CHK_XALMB:
			// SVALM B
			hubcp132_SetSvAlm(hDev, 0, 0, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XALMA, BST_UNCHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XALMB, BST_CHECKED);
			break;

		// Y
		case IDC_CHK_YELSA:
			// ELS A
			hubcp132_SetEls(hDev, 1, 1, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_YELSA, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_YELSB, BST_UNCHECKED);
			break;

		case IDC_CHK_YELSB:
			// ELS B
			hubcp132_SetEls(hDev, 1, 0, 0);			
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_YELSA, BST_UNCHECKED);
			CheckDlgButton(hWnd, IDC_CHK_YELSB, BST_CHECKED);
			break;

		case IDC_CHK_YALMA:
			// SVALM A
			hubcp132_SetSvAlm(hDev, 1, 1, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_YALMA, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_YALMB, BST_UNCHECKED);
			break;

		case IDC_CHK_YALMB:
			// SVALM B
			hubcp132_SetSvAlm(hDev, 1, 0, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_YALMA, BST_UNCHECKED);
			CheckDlgButton(hWnd, IDC_CHK_YALMB, BST_CHECKED);
			break;

		// T[{C^[tF[X
		// X
		case IDC_CHK_XSVON:
			// T[{I
			hubcp132_SvOn(hDev, 0x01);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XSVON, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XSVOF, BST_UNCHECKED);
			break;

		case IDC_CHK_XSVOF:
			// T[{It
			hubcp132_SvOff(hDev, 0x01);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XSVOF, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XSVON, BST_UNCHECKED);
			break;

		// Y
		case IDC_CHK_YSVON:
			// T[{I
			hubcp132_SvOn(hDev, 0x02);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_YSVON, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_YSVOF, BST_UNCHECKED);
			break;

		case IDC_CHK_YSVOF:
			// T[{It
			hubcp132_SvOff(hDev, 0x02);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_YSVOF, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_YSVON, BST_UNCHECKED);
			break;
	}
	return 0;
}

//
// user timer
//
LRESULT cirTimer( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	switch( wParam ) {
		case IDD_TMR:
			cirSts( hWnd );
			break;
		default:
			return DefWindowProc( hWnd, uMessage, wParam, lParam );
	}
	return 0 ;
}

//
//	Xe[^XǍ
//
void cirSts( HWND hWnd )
{
	WORD	wAx,wMst,wSst,wSpd;
	DWORD	dwRet,dwErr,dwInt,dwPos;

	//  XCXe[^X̓Ǎ
	dwRet = hubcp132_ReadMainSts( hDev, 0, &wMst );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		return;
	}

	//  I
	if( wMst & 0x0030 ) {
		if( wMst & 0x0010 ) {		//  G[
			SetDlgItemText( hWnd, IDC_STA_XINT, "G[I" );			
				
			//  XG[Xe[^XǍ
			dwRet = hubcp132_ReadErrorSts( hDev, 0, &dwErr );
			if( dwErr & 0x20 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "+XELSONɂ~" );
			}
			if( dwErr & 0x40 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "-XELSONɂ~" );
			}
			if( dwErr & 0x80 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "XSVALMONɂ~" );
			}
			if( dwErr & 0x200 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "EMGONɂ~" );
			}
			if( dwErr & 0x2000 ) {
				//  YG[Xe[^XǍ
				dwRet = hubcp132_ReadErrorSts( hDev, 1, &dwErr );
				if( dwErr & 0x20 ) {
					SetDlgItemText( hWnd, IDC_STA_XERR, "+YELSONɂ~" );
				}
				if( dwErr & 0x40 ) {
					SetDlgItemText( hWnd, IDC_STA_XERR, "-YELSONɂ~" );
				}
				if( dwErr & 0x80 ) {
					SetDlgItemText( hWnd, IDC_STA_XERR, "YSVALMONɂ~" );
				}
			}
		} else {
			//  Cxg(~)
			//  XCxgXe[^XǍ
			dwRet = hubcp132_ReadEventSts( hDev, 0, &dwInt );
			if( dwInt & 1 ) {
				SetDlgItemText( hWnd, IDC_STA_XINT, "~" );
			}
		}
		EnableWindow( GetDlgItem(hWnd, IDC_BTN_CW), TRUE );
		EnableWindow( GetDlgItem(hWnd, IDC_BTN_CCW), TRUE );
	}
	
	for( wAx = 0; wAx < 2;  wAx++ ) {
		// TuXe[^X̓Ǎ
		dwRet = hubcp132_ReadSubSts( hDev, wAx, &wSst );
		if( dwRet ) {
			KillTimer( hWnd, IDD_TMR );
			return;
		}

		//  SVON ʕ\(SVON ONFΐF\CSVON OFFFF\)
		if( wSst & 0x0001 )	
			SendDlgItemMessage( hWnd, IDC_BIT_XSON + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_BIT_XSON + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

		//  SVALM ʕ\(SVALM ONFԐF\CSVALM OFFFF\)
		if( wSst & 0x0800 )	
			SendDlgItemMessage( hWnd, IDC_BIT_XALM + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gRed );
		else				
			SendDlgItemMessage( hWnd, IDC_BIT_XALM + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

		//  +ELS ʕ\(ELS ONFԐF\CELS OFFFF\)
		if( wSst & 0x1000 )	
			SendDlgItemMessage( hWnd, IDC_BIT_XPEL + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gRed );
		else				
			SendDlgItemMessage( hWnd, IDC_BIT_XPEL + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

		//  -ELS ʕ\(ELS ONFԐF\CELS OFFFF\)
		if( wSst & 0x2000 )	
			SendDlgItemMessage( hWnd, IDC_BIT_XMEL + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gRed );
		else				
			SendDlgItemMessage( hWnd, IDC_BIT_XMEL + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		
		//  ݎw߈ʒu̓Ǎ
		dwRet = hubcp132_ReadCtr( hDev, wAx, 1, &dwPos );
		if( dwRet ) {
			KillTimer( hWnd, IDD_TMR );
			return;
		}
			
		//  ݎw߈ʒu̕\
		SetDlgItemInt( hWnd, IDC_STA_XPOS + wAx * 100, dwPos, TRUE );
	}
			
	//  ݑx̓Ǎ
	dwRet = hubcp132_ReadSpd( hDev, 0, &wSpd );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		return;
	}
	
	//  ݑx̕\
	SetDlgItemInt( hWnd, IDC_STA_XSPD, wSpd, FALSE );
}

//	~ʕԓ̃_CAO{bNX̏
void cirLoad( HWND hWnd )	
{	
	// {^ݒ	
	CheckDlgButton( hWnd, IDC_CHK_XELSB, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_XALMB, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_XSVOF, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_YELSB, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_YALMB, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_YSVOF, BST_CHECKED );

	// I_ʒuGfB^ݒ
	SetDlgItemText( hWnd, IDC_EDT_XEND, "0" );
	SendDlgItemMessage( hWnd, IDC_EDT_XEND, EM_SETLIMITTEXT, 8, 0 );
	SetDlgItemText( hWnd, IDC_EDT_YEND, "0" );
	SendDlgItemMessage( hWnd, IDC_EDT_YEND, EM_SETLIMITTEXT, 8, 0 );

	// SʒuGfB^ݒ
	SetDlgItemText( hWnd, IDC_EDT_XCNTR, "500" );
	SendDlgItemMessage( hWnd, IDC_EDT_XCNTR, EM_SETLIMITTEXT, 8, 0 );
	SetDlgItemText( hWnd, IDC_EDT_YCNTR, "0");
	SendDlgItemMessage( hWnd, IDC_EDT_YCNTR, EM_SETLIMITTEXT, 8, 0 );
}
